//+------------------------------------------------------------------+
//|                                                 prognozVolat.mq4 |
//|                             Copyright  2009, Viatcheslav Suvorov| 
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Red
//---- input parameters
extern int     Avr_period = 5;
extern int     Add_period = 5;
extern double  Extr_k = 1.3;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, ExtMapBuffer3);   
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, ExtMapBuffer4);   

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Avr[];
   double k=0;
   double k1=0;
   ArrayResize(Avr,MathRound(60*24/Period()));    
   int counted_bars = IndicatorCounted()+1;
   int redraw = Bars - counted_bars;
   if (redraw < 1000) redraw = 1000;
   for(int i = redraw; i >=0 ; i--){
//   for(int i = 1000; i >=0 ; i--){
     int h=TimeHour(Time[i]);
     int m=TimeMinute(Time[i]);
     int ind=MathRound((h*60+m)/Period());
     double HL=(High[i]-Low[i]);
     Avr[ind]=(HL + (Avr_period-1)*Avr[ind])/Avr_period;
     ExtMapBuffer1[i]=HL;  
     ExtMapBuffer3[i-1]=(Avr[ind+1]+(Add_period-1)*ExtMapBuffer3[i])/Add_period;
          
     if ((ExtMapBuffer1[i]>Extr_k*ExtMapBuffer3[i]) && (ExtMapBuffer3[i]>0)) k=(ExtMapBuffer1[i]/ExtMapBuffer3[i]+(Add_period-1)*k)/Add_period;
     if ((Extr_k*ExtMapBuffer1[i]<ExtMapBuffer3[i]) && (ExtMapBuffer1[i]>0)) k1=(ExtMapBuffer3[i]/ExtMapBuffer1[i]+(Add_period-1)*k1)/Add_period; 
  
     
     if (k>0) ExtMapBuffer2[i-1]=k*ExtMapBuffer3[i-1]; else ExtMapBuffer2[i-1]=ExtMapBuffer2[i];
     if (k1>0) ExtMapBuffer4[i-1]=ExtMapBuffer3[i-1]/k1; else ExtMapBuffer4[i-1]=ExtMapBuffer4[i];
      
   }//for
//----
   return(0);
  }
//+------------------------------------------------------------------+